Thanks for contributing to `glam`! These guidelines will try make the process
painless and efficient.

The short guide to contributing is [open a github issue]. Pull requests are
welcome for bug fixes, documentation improvements and optimizations. For
anything else it would be best to discuss it first.

# Questions

If you have a question about the usage of this library please
[open a github issue]. That's the easiest way to get support right now.

# Bugs

If you find a bug please [open a github issue] or submit a pull request. A unit
test for any bug that slipped through existing coverage would also be greatly
appreciated.

# New functions and methods

If `glam` is missing functionality on existing types, [open a github issue]
describing what feature you would like added and ideally what your use case is
for it just so I have a better understanding of the feature. I'd like to keep
`glam` reasonably light functionality wise initially but commonly used
functionality that is missing is very welcome. If you do submit a pull request
please ensure any new functionality also has a test.

# New types

If you would like to add a new type to `glam` please [open a github issue]. Only
`f32` has been supported for now but long term I'd like to support people with
other needs. I am interested in what types you feel you need and what you would
use them for. Examples might be `i32` or `f64` vectors or generic types. I don't
want to rush to support new types until the API has stabilised a bit more but it
would be good to collect information on functionality people would like to see
in `glam`.

# Optimizations

If you feel some functionality could be optimized please [open a github issue]
or submit a pull request. Any optimization pull request should include a
benchmark if there isn't one already so I can confirm the performance
improvement.

# Documentation

If you feel any documentation could be added or improved please
[open a github issue] or submit a pull request.

[open a github issue]: https://github.com/bitshifter/glam-rs/issues
